/*
 ********************************************
 * MonitorAsaPrev - Servidor de Servios    *
 * Verso: 1.0 - 05/2014                    *
 *------------------------------------------*
 * Autor : Alexandre Simes                 *
 * ******************************************
*/

#include "directry.ch"
#include "fileio.ch"
#include "hbwin.ch"
#include "dbinfo.ch"
#include "simpleio.ch"
#include "hbthread.ch"
#include "hbclass.ch"
#include "common.ch"
#include "hbgtinfo.ch"
#include "hbver.ch"
#include "inkey.ch"
#include "setcurs.ch"
#include "achoice.ch"
#include "hbdyn.ch"
#include "error.ch"

#define HB_SYMBOL_UNUSED( symbol )  ( symbol := ( symbol ) )

#define AzulHTML     '<span style="color:#0000FF">'
#define VermelhoHTML '<span style="color:#FF0000">'
#define QuebraHTML   '<br>'

FUNCTION Main()

   aArq := {"demo.prg"}
   
   IF Len( aArq ) > 0
      WITH Object ClEmailSSL():New()
           :cUser     := "xhbsistemas"
           :cPassword := "xhbsistemas"
           :cFrom     := "xhbsistemas@gmail.com"
           :cAlias    := "Sistema Demo <" + :cFrom + "> "
           :aTo       := {"Suporte <sistemas@gmail.com>"}
           //:aCC       := {"Fulano <fulando@yahoo.com.br>"}
           :cHost     := "smtp.gmail.com"
           :cAssunto  := "Log de erro de sistema em: " + Hb_DtoC( Date(), "DD/MM/YYYY" ) + " " + Time()
           :cMensagem := AzulHTML + "Log de erro de sistema " + ;
                         QuebraHTML + ;
                         "Em: " + Hb_DtoC(Date(), "DD/MM/YYYY") + " " + Time() + ;
                         QuebraHTML + ;
                         "Estao: " + Hb_GetEnv( "computername" ) + ;
                         QuebraHTML + ;
                         VermelhoHTML + ;
                         "Feito pelo Monitor AsaPrev Verso 3. SSL + FTP" + ;
                         QuebraHTML + ;
                         Hb_Version() + ;
                         QuebraHTML + ;
                         Hb_Compiler() + ;
                         QuebraHTML
                         
           :aArquivo   := aArq
           //:cUrlImagem := 'https://lh3.googleusercontent.com/ucCkWpEGtqSPhlMHm910D8uO7BPWTOBjTL6EqPIVfFZNrUCefLySawCJmGJVFMu3LTMNxU2RzBwN6JQygsTYbBy8Wk2Xc4TSiw-jIi2ytwSdfkfFYye2wt115C7XjEiNWuXG2UtO3GNHrkglSC5cbB0jgv-sw_E5ShR0saTqFwYciE5HMghWlwYADIuyu_UgTc7PSr07rewE4tNdSHMU9YXWVOtd3qGAyGo1HTLM8qlmljLANavuLa_O5tqhAKewJvtUsO_QvAkXycF3OFtWiE8WosEj9uF1jc8EoOX_JA7Ww03VIyszEPIuu0Vid7VvIyKrj1ohxA-mkCr_C46z3ub5vClI2jWLribCvfkI8h_PAaaZ-YgYdOcYPVv1K6Y-1tkLWkmmJ1ujZHXRv4D2a7s26qz8ssQgrA3l4TiiN-CVKYni0nCoM1GW5a45VasA6BEJ_dCieKngsMXYOXEbkRyt-m34QBat4tS7hUTDVlj9fjfnwWn78SSshZUXWj1A1XrqhaNHAU05AayHcSOMe5aBCKWYVX_1VjxFR2ELxPDVfP5MDV8anUX1_uXZ-iqEpSDt3VjYTshLDAO1iUyqh0KHcOM4wYHlr1XHm3w_7jVZW52-uw6u9KMmfRJimSinFXuTnM7gjHf3-5A6FWt_6I1cAfMsEt5_=w279-h83-no' //'https://lh3.googleusercontent.com/-1STLYuQgAlo/V0L-vdc8gRI/AAAAAAAABOI/wIlYAdl-Z8wMpNNPOmZ7G_z-enVMiv2XQCCo/s100/icon-saas-update-300x216.png'
           :cImagem   := [AVI\bug-icone-8957-32.png]
           :nPorta     := 465
           :lSSL       :=( :nPorta == 465 )
           :Send()    
           IF :lRet
              Alert("Email Enviado")
           ENDIF
      END
      
   ENDIF
             
    
RETURN Nil


INIT FUNCTION AppSetup

   REQUEST HB_LANG_PT
   
   REQUEST HB_CODEPAGE_PTISO
   
   Hb_LANGSELECT("PT")
   
   Hb_CDPSELECT( "PTISO" ) 
   
   Hb_gtReload( "WVG" )
   
   SetMode( 27, 80 )
   
   CLS

   Hb_gtInfo( HB_GTI_CLOSEMODE, 0 )
   
   Hb_gtInfo( HB_GTI_FONTNAME, "Lucida Console" )
   
   Hb_gtInfo( HB_GTI_WINTITLE, "Teste com tip_MailSend" )
   
   Hb_gtInfo( HB_GTI_COMPATBUFFER, .T. ) 
   
   //Hb_gtInfo( HB_GTI_ICONFILE, "AVI\ASAPREV.ICO" )
   
   //hb_gtInfo( HB_GTI_CLOSABLE, .F. )
   
   Hb_gtInfo( HB_GTI_MAXIMIZED, .T. )
  
   Hb_gtInfo( HB_GTI_SPEC, HB_GTS_WNDSTATE, HB_GTS_WS_MAXIMIZED )
   
   //Hb_gtInfo( HB_GTI_RESIZABLE, .F. )
   
   //Hb_gtInfo( HB_GTI_NOTIFIERBLOCKGUI, {|nEvent| Sair( nEvent ) } )
  
   SetColor( "N/W,N/GR*,,,N/W" )
    
   CLS
   
   
RETURN Nil


#pragma BEGINDUMP

#include <windows.h>

#include "hbapi.h"

#include <olectl.h>

HB_FUNC( WIN_N2PP )
{
   hb_retptr( ( void * ) ( HB_PTRDIFF ) hb_parnint( 1 ) );
}

HB_FUNC( WVG_N2P )  /* NOTE: Unsafe: allows to pass arbitary pointers to functions, potentially causing a crash or worse. */
{
   hb_retptr( HB_ISPOINTER( 1 ) ? hb_parptr( 1 ) : ( void * ) ( HB_PTRDIFF ) hb_parnint( 1 ) );
}

#pragma ENDDUMP

#pragma begindump

#define _WIN32_IE 0x0500
#define HB_OS_WIN_32_USED
#ifdef __POCC__
   #define _WIN32_WINNT 0x0500
#else
   #define _WIN32_WINNT 0x0400
#endif

#include <winsock2.h>
#include "hbapi.h"
#include "hbapiitm.h"

/*
 * PING( cURI, [nTimeOut], [bUserFunc] ) -> nError | aResult
 * Esta funo efetua um PING no IP ou NOME passado como argumento. Ela retorna
 * um array com as informaes disponiveis ou um numero indicando erro no processo.
 * O segundo parametro indica tempo de time-out e o segundo  um code-block que
 * retorna .T. indicando que o processo de PING deve se repetir ou .F. para
 * abortar o processo. No caso do parametro bUserFunc, ele receber como argumento
 * um ARRAY com as mesmas informaes retornadas ali embaixo.
 *
 * Os codigos de erro suportados so:
 *    1 - Parametro invalido.
 *    2 - Falha ao inicializar a WinSock
 *    3 - Unable to locate ICMP.DLL
 *    4 - Could not find IP address
 *    5 - Failed to get proc addr for functions
 *    6 - Unable to open ping service
 *    7 - Failed to allocate global ping packet buffer
 *    8 - Error obtaining info from ping packet
 *
 * O array retornado em caso de xito possui as seguintes informaes:
 *    1 - Sequencia numerica de envio
 *    2 - Endereo IPv4 alcanado ou em caso de erro a MSG retornada pelo sistema
 *    3 - Tamanho do pacote de dados enviado ou -1 em caso de erro.
 *    4 - RTT em microsegundos ou -1 em caso de erro.
 *    5 - TTL ou -1 em caso de erro.
 *
 * Baseado no excelente exemplo disponivel em:
 *    http://tangentsoft.net/wskfaq/examples/dllping.html
 *
 * 15/01/2010 - 12:42:49
 */

typedef struct {
    unsigned char Ttl;                         // Time To Live
    unsigned char Tos;                         // Type Of Service
    unsigned char Flags;                       // IP header flags
    unsigned char OptionsSize;                 // Size in bytes of options data
    unsigned char *OptionsData;                // Pointer to options data
} IP_OPTION_INFORMATION, * PIP_OPTION_INFORMATION;

typedef struct {
    DWORD Address;                             // Replying address
    unsigned long  Status;                     // Reply status
    unsigned long  RoundTripTime;              // RTT in milliseconds
    unsigned short DataSize;                   // Echo data size
    unsigned short Reserved;                   // Reserved for system use
    void *Data;                                // Pointer to the echo data
    IP_OPTION_INFORMATION Options;             // Reply options
} IP_ECHO_REPLY, * PIP_ECHO_REPLY;

typedef HANDLE (WINAPI* pfnHV)(VOID);
typedef BOOL (WINAPI* pfnBH)(HANDLE);
typedef DWORD (WINAPI* pfnDHDPWPipPDD)(HANDLE, DWORD, LPVOID, WORD,
        PIP_OPTION_INFORMATION, LPVOID, DWORD, DWORD); // evil, no?

HB_FUNC( PING )
{
    WSADATA wsaData;
    HINSTANCE hIcmp = NULL;
    struct hostent* phe;
    pfnHV pIcmpCreateFile;
    pfnBH pIcmpCloseHandle;
    pfnDHDPWPipPDD pIcmpSendEcho;
    HANDLE hIP;
    PIP_ECHO_REPLY pIpe = NULL;
    char acPingBuffer[64];
    const char *szHost = hb_parcx(1);
    const int nTimeOut = hb_parni(2);
    PHB_ITEM pBlock = hb_param( 3, HB_IT_BLOCK );     // Version 2.x - Codeblock support!
    PHB_ITEM pRet = (PHB_ITEM) 0;

    if (!szHost)
    {
      hb_retni(1);   // 1 - Parametro invalido.
      return;
    }

    /* Initialize WinSock */
    if (WSAStartup(MAKEWORD(1, 1), &wsaData) == 0)
    {
       /* Load the ICMP.DLL */
       hIcmp = (HINSTANCE) LoadLibrary("ICMP.DLL");

       if (hIcmp)
       {
          /* Look up an IP address for the given host name */
          if ((phe = gethostbyname(szHost)) != 0)
          {
             /* Get handles to the functions inside ICMP.DLL that we'll need */
             pIcmpCreateFile  = (pfnHV)GetProcAddress(hIcmp, "IcmpCreateFile");
             pIcmpCloseHandle = (pfnBH)GetProcAddress(hIcmp, "IcmpCloseHandle");
             pIcmpSendEcho    = (pfnDHDPWPipPDD) GetProcAddress(hIcmp, "IcmpSendEcho");
             
             if (pIcmpCreateFile && pIcmpCloseHandle && pIcmpSendEcho )
             {
                 hIP = pIcmpCreateFile();

                 if (hIP != INVALID_HANDLE_VALUE)
                 {
                     /* Build ping packet */
                     pIpe = (PIP_ECHO_REPLY) hb_xalloc( sizeof(IP_ECHO_REPLY) + sizeof(acPingBuffer));

                     if (pIpe)
                     {
                        PHB_ITEM pArray = hb_itemArrayNew( 5 );
                        int i, c;

                        /*
                         * If he spent a codeblock let him decide when to stop,
                         * otherwise we do LOOP only one time.
                         * 02/03/2011 - 15:48:26 - [vailtom]
                         */
                        if( pBlock && HB_IS_BLOCK( pBlock ) )
                           c = 255;
                        else
                           c = 1;
                        
                        for ( i = 1; i <= c; i++ )
                        {
                           DWORD dwStatus;

                           memset( acPingBuffer, '\xAA', sizeof(acPingBuffer) );
                           memset( pIpe, '\0', sizeof(IP_ECHO_REPLY) + sizeof(acPingBuffer) );

                           pIpe->Data = acPingBuffer;
                           pIpe->DataSize = sizeof(acPingBuffer);

                           /* Send the ping packet */
                           dwStatus = pIcmpSendEcho(hIP, *((DWORD*)phe->h_addr_list[0]),
                                         acPingBuffer, sizeof(acPingBuffer), NULL, pIpe,
                                            sizeof(IP_ECHO_REPLY) + sizeof(acPingBuffer),
                                             ((nTimeOut) ? nTimeOut*1000 : 1000));

                           if (dwStatus != 0)
                           {
                              char s[18];

                              sprintf( s, "%03d.%03d.%03d.%03d",
                                       (int)(LOBYTE(LOWORD(pIpe->Address))),
                                       (int)(HIBYTE(LOWORD(pIpe->Address))),
                                       (int)(LOBYTE(HIWORD(pIpe->Address))),
                                       (int)(HIBYTE(HIWORD(pIpe->Address))) );
                                       
                              hb_arraySetNI( pArray, 1, i );
                              hb_arraySetC ( pArray, 2, s );
                              hb_arraySetNI( pArray, 3, (int)(pIpe->DataSize) );
                              hb_arraySetNI( pArray, 4, (int)(pIpe->RoundTripTime) );
                              hb_arraySetNI( pArray, 5, (int)(pIpe->Options.Ttl) );

                              if( pBlock && HB_IS_BLOCK( pBlock ) )
                                 pRet = hb_itemDo( pBlock, 1, pArray );

                           } else {
                                 LPVOID lpMsgBuf;

                                 FormatMessage(
                                     FORMAT_MESSAGE_ALLOCATE_BUFFER |
                                     FORMAT_MESSAGE_FROM_SYSTEM |
                                     FORMAT_MESSAGE_IGNORE_INSERTS,
                                     (LPCVOID) NULL,
                                     GetLastError(),
                                     MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
                                     (LPTSTR) &lpMsgBuf,
                                     0,
                                     NULL );

                                 /*
                                  * Como  um indicativo de erro, colocamos todos
                                  * os valores como "default", ou seja, vazios.
                                  * 02/03/2011 - 15:25:49 - [vailtom]
                                  */
                                 hb_arraySetC ( pArray, 2, (const char *) lpMsgBuf );
                                 hb_arraySetNI( pArray, 3, -1 );
                                 hb_arraySetNI( pArray, 4, -1 );
                                 hb_arraySetNI( pArray, 5, -1 );
                                 
                                 LocalFree( lpMsgBuf );
      
                                 if( HB_IS_BLOCK( pBlock ) )
                                    pRet = hb_itemDo( pBlock, 1, pArray );

                                 ///hb_retni(8);   // 8 - Error obtaining info from ping packet
                           }
                           
                           if ( pRet )
                           {
                              /* Forces manually FOR break */
                              if ( !hb_itemGetL( pRet ) )
                                 i = c+1;
                                 
                              /* Release Memory */
                              hb_itemRelease( pRet );
                           }
                        }

                        /* Release Memory */
                        hb_itemReturn( pArray );
                        hb_itemRelease( pArray );
                        
                     } else {
                        hb_retni(7);   // 7 - Failed to allocate global ping packet buffer
                     }

                 } else {
                     hb_retni(6);    // 6 - Unable to open ping service
                 }

             } else {
                 hb_retni(5);   // 5 - Failed to get proc addr for functions
             }
          } else {
              hb_retni(4);   // 4 - Could not find IP address
          }
       } else {
           hb_retni(3);   // 3 - Unable to locate ICMP.DLL
       }
    } else {
      hb_retni(2);   // 2 - Falha ao inicializar a WinSock
    }

    if (pIpe)
      hb_xfree( (void *) pIpe);

    if (hIcmp)
      FreeLibrary(hIcmp);
      
    WSACleanup();
    return;
}
#pragma enddump