#require "hbssl"
#require "hbtip"
#include "simpleio.ch"
#include "fileio.ch"
#include "hbclass.ch"
#include "hbthread.ch"

#define HB_SYMBOL_UNUSED( symbol )  ( symbol := ( symbol ) )
*-----------------------------------------------------------------------------------------------------------------------------*
* Classe : ClEmailSSL
* Projeto: 
* Autor  : Alexandre Simes
* Criao: 12/05/2016
*-----------------------------------------------------------------------------------------------------------------------------*

#if ! defined( __HBSCRIPT__HBSHELL )
   REQUEST __HBEXTERN__HBSSL__
#endif

MEMVAR lRetorno

CREATE CLASS ClEmailSSL
   PROTECTED :
   
   DATA cAssunto
   DATA cMensagem
   DATA cFonte
   DATA cImagem
   DATA lInformativo
   DATA cUser
   DATA cPassword
   DATA cAlias
   DATA cFrom
   DATA aTo
   DATA aCC
   DATA aBCC
   DATA cHost
   DATA nPriority
   DATA lRead
   DATA nPorta
   DATA lSSL
   DATA nTimeOut
   DATA cUrlImagem
   DATA cImagem
   DATA cImagem
   DATA cBodyTemp
   DATA lRet
   
   EXPORTED :
   
   VAR aArquivo     AS Array   INIT {} 
   VAR cAssunto     AS String  INIT ""
   VAR cMensagem    AS String  INIT ""
   VAR cImagem      AS String  INIT ""
   VAR lInformativo AS Logical INIT .F.
   VAR cUser        AS String  INIT ""
   VAR cPassword    AS String  INIT ""
   VAR cAlias       AS String  INIT ""
   VAR cFrom        AS String  INIT ""
   VAR aTo          AS Array   INIT {}
   VAR aCC          AS Array   INIT {}
   VAR aBCC         AS Array   INIT {}
   VAR cHost        AS String  INIT ""
   VAR nPriority    AS Integer INIT 3
   VAR lRead        AS Logical INIT .F.
   VAR nPorta       AS Integer INIT 465
   VAR lSSL         AS Logical INIT .F.
   VAR nTimeOut     AS Integer INIT 2000
   VAR cUrlImagem   AS String  INIT ""
   VAR cBodyTemp    AS String  INIT ""
   VAR lRet         AS Logical INIT .F.
   
   METHOD Send()      
   METHOD SendEmailSSL( cHost,;
                     nPorta,;
                     cAlias,;
                     aTo,;
                     aCC,;
                     aBcc,;
                     cBodyTemp,;
                     cAssunto,;
                     aArquivo,;
                     cUser,;
                     cPassword,;
                     nPriority,;
                     lRead,;
                     nTimeOut,;
                     lSSL )
   METHOD PNGAsa( cImagem )
   METHOD HtmlEncodeJPEG( cFileContent )
   ENDCLASS

METHOD Send CLASS ClEmailSSL
//METHOD ClEmailSSL:Send
LOCAL bImagem, nWidth, nHeight

   IF ! tip_SSL()
      RETURN Nil
   ENDIF

   IF ! Empty( ::cUrlImagem ) .AND. Empty( ::cImagem )
      ::cImagem := [<p><IMG SRC=] + '"' + ::cUrlImagem + '"' + [></p>]
   ENDIF
   
   ::cFonte := '<font color="#0000FF" face="lucida console" size="3">'
   
   IF ! Empty( ::cImagem ) .AND. Empty( ::cUrlImagem )
      Fi_Initialise()
      bImagem   := Fi_Load( FIF_PNG, ::cImagem, PNG_DEFAULT )
      nWidth    := Fi_GetWidth( bImagem )
      nHeight   := Fi_GetHeight( bImagem )
      ::cImagem := [<p><IMG SRC=] + ::HtmlEncodeJPEG( ::PNGAsa() ) + [ width = Hb_Ntos( nWidth ) height = Hb_Ntos( nHeight )></p>]
      Fi_Deinitialise()
   ENDIF
    
   ::cMensagem   := ::cImagem + ::cFonte + ::cMensagem
   
   ::cBodyTemp   := Hb_Getenv( "temp" ) + Hb_Ps() + "BODY.HTM"
   
   nFileHandle := fCreate( ::cBodyTemp )
                  fWrite( nFileHandle, ::cMensagem )
                  fClose( nFileHandle )
   
   lRetorno := .F.
                                   
   ::lRet := ::SendEmailSSL( ::cHost,;
                             ::nPorta,;
                             ::cAlias,;
                             ::aTo,;
                             ::aCC,;
                             ::aBcc,;
                             ::cBodyTemp,;
                             ::cAssunto,;
                             ::aArquivo,;
                             ::cUser,;
                             ::cPassword,;
                             ::nPriority,;
                             ::lRead,;
                             ::nTimeOut,;
                             ::lSSL )
   
   ::lRet := lRetorno
   
RETURN ::lRet

//#pragma -km+
METHOD PNGAsa( cImagem ) CLASS ClEmailSSL
   #pragma __binarystreaminclude "avi\update.png" | RETURN %s
   
METHOD HtmlEncodeJPEG( cFileContent ) CLASS ClEmailSSL
LOCAL cTxt, oEncoder := TipEncoderBase64():New()
   
   #ifdef hb32  
      cTxt := ["] + "data:" + tip_FileNameMimeType( "update.png", "ptprapqp", "ptprapqp" ) + "; base64," + oEncoder:Encode( cFileContent ) + ["]
   #else
      cTxt := ["] + "data:" + Hb_mimeFName( "update.png", "ptprapqp", "ptprapqp" ) + "; base64," + oEncoder:Encode( cFileContent ) + ["]
   #endif

RETURN cTxt

METHOD SendEmailSSL( cHost,;
                     nPorta,;
                     cAlias,;
                     aTo,;
                     aCC,;
                     aBcc,;
                     cBodyTemp,;
                     cAssunto,;
                     aArquivo,;
                     cUser,;
                     cPassword,;
                     nPriority,;
                     lRead,;
                     nTimeOut,;
                     lSSL )

            lRetorno := tip_MailSend( cHost,;
                                      nPorta,;
                                      cAlias,;
                                      aTo,;
                                      aCC,;
                                      aBcc,;
                                      cBodyTemp,;
                                      cAssunto,;
                                      aArquivo,;
                                      cUser,;
                                      cPassword,;
                                      "",;
                                      nPriority,;
                                      lRead,;
                                      .F.,;
                                      .F.,;
                                      nTimeOut,;
                                      NIL,;
                                      .T.,;
                                      lSSL,;
                                      NIL,;
                                      NIL,;
                                      NIL )
RETURN lRetorno